Subject: Re: RFC: Modernizing the contept of plumbing v.s. porcelain

From: Junio C Hamano <[email-masked]>
Date: Wed, 09 Dec 2020 11:38:33 -0800

Ævar Arnfjörð Bjarmason <[email-masked]> writes:

> A lot of external guides and people's mental models of /usr/bin/git as a
> scriptable client reference the concept of plumbing & porcelain. Just
> one such example [1] prompted me to write this E-Mail.
>
> I've wondered if we shouldn't be updating this concept to reflect the
> reality on the ground in the git command ecosystem.

The example tells me that they are trying to be a good ecosystem
citizen by sticking to the plumbing and refraining from using
Porcelain command when writing their script.  The practice gives
them assurance that we won't unilaterally break them, and gives us
the freedom to improve Porcelain for human consumption.

> I.e. if you look at "git help git"'s list of plumbing v.s. porcelain it
> makes no mention or distinction between those commands & functionalities
> that are truly transitory "porcelain". E.g. the specific error message a
> command might return, and those that are effectively plumbing. E.g. some
> "git config" functionality, "git init", the pretty formats in "git log"
> etc.
>
> I'm not quite sure what I'm proposing if anything, just putting out
> feelers to see if others think this documentary status quo has drifted
> from reality.
>
> One potential change would be to mostly/entirely remove the
> "porcelain/ancillary/plumbing" distinction in "git help git" (except
> maybe e.g. "hash-object") and instead make a mention of the status of
> the command at the top of its own manpage, which could then also
> (e.g. in the case of "git log") document the API reliability of its
> various sub-features.
>
> 1. https://gitlab.com/gitlab-org/gitaly/-/blob/afc90e3c2/doc/serverside_git_usage.md#L11-17

I am not sure what you want to propose as a solution, but even
before that, what problem you are perceiving.  Are you wondering if
it may be a better general direction for us to tell "no, no, there
is no value in sticking to the plumbing because we will break you
anyway in the future" to those who wrote [1]?